/**
For purposes of starting to impose a little order, below is a list of DOM modifications:
All form elements with labels link back to them.
All form labels gain an extra empty text node for error text.
window.onload is overridden
All text areas with a maximum length must set it in the variable textLengthLimit  (name picked to avoid collisions)
textarea onchange is currently set to inputCount function if textLengthLimit is set.
**/
if(window.IE===undefined) IE = false;
function _ID(id) {return document.getElementById(id);}
function _NODE(s) {return document.createElement(s); }
var TRIM = new RegExp('^\\s*|\\s*$','g')
var LINNL = new RegExp('([^\r])\n','g');
var LINNL2 = new RegExp('\n\n','g');
var LINNL3 = new RegExp('^\n');
var MACNL = new RegExp('\r([^\n])','g');
var MACNL2 = new RegExp('\r\r','g');
var MACNL3 = new RegExp('\r$');

// this deliberately does not play nice with any existing onload.
window.onload = function() // global window onload
{
    var a = document.getElementsByTagName("a");
    for(var i=0;i<a.length;i++)
        if(hasClass(a[i],"new_window"))
            a[i].onclick = openNew;
    if (window.pageWindowOnload) // might be better to just use addEventListner, but I wanted standard locations and ability to override
        pageWindowOnload();
    if (window.pageFormInit)
        pageFormInit();
    globalFormInit();
    if (IE)
        fixupIE();
}

function openNew()  // _blank + (new Date()).getTime() if unique wanted
{
    window.open(this.href,"_blank")  // ... or, as noted. "_blank"+(+new Date)
    return false;
}

function globalFormInit()
{
    // link all form elements back to their labels for javascript errors
    var l = document.getElementsByTagName("label");
    var eid;
    var e;
    var t;
    for(i=0;i<l.length;i++)
    {
        if (l[i].htmlFor)  // used getAttribute originally. which of course is broken in IE. shocking.
        {
            e = _ID(l[i].htmlFor);
            if (e.getAttribute("maxlength") && !e.disableMaxLengthDisplay)
                e.textLengthLimit = parseInt(e.getAttribute("maxlength"),10);

			// IE8 has this issue too. 
            //if (IE && e.textLengthLimit > 1000000) // IE is kind of an idiot about this, looks like it sets it to some maxint value, but not going to take its word for it
            if (e.textLengthLimit > 1000000)
                e.textLengthLimit = null;

            t = document.createTextNode("");
            e.errorText = l[i].appendChild(t);
            e.labelRef = l[i];
            if (e.textLengthLimit!==undefined)
                if (e.nodeName.toLowerCase()=='textarea')
                    e.onkeyup = inputCount;

            // used to start lines with * to require them - could possibly handle both
            // if (l[i].firstChild.data.charAt(0)=="*" && e.required===undefined)
            if (/^\s*\*/.test(l[i].firstChild.data) && e.required===undefined)
                e.required = true;
            else if (l[i].firstChild.data.indexOf("(required)")!=-1 && e.required===undefined)
            {
                l[i].firstChild.data = l[i].firstChild.data.replace(/\s*\(required\)/,'');
                e.required = true;
            }
            setErrorDefault(e);
        }
    }
}
function getXHR()
{
	var xhr;
	try { xhr=new XMLHttpRequest; } // necessary due to IE7 not responding properly to an XMLHttpRequest defined check
	catch (e)
	{
		try { xhr=new ActiveXObject("Msxml2.XMLHTTP"); } 
		catch (e)
		{
			try { xhr=new ActiveXObject("Microsoft.XMLHTTP"); } 
			catch (e) { xhr = false; }                                                                                                                      
		}
	}
	return xhr;
}


function removeClass(e,c)
{
    if (!e.className) return;
    e.className = e.className.replace(new RegExp("(^|\\s+)"+c),'');
}
function addClass(e,c) {
    if (!e.className)
        e.className = c;
    else if (!hasClass(e,c))
        e.className += " "+c;
}
function hasClass(e,c)
{
    if (!e.className)
        return false;

    return (new RegExp("(^|\\s+)"+c+"(\\s+|$)")).test(e.className);
}

function delayedReload(x)
{
  	setTimeout(function() { window.location.reload(true) }, x);
}
function closeRefresh()
{
  if (opener && !opener.closed) 
  	opener.delayedReload(500);

  close();
}

/******************** general form manipulation *******************************/

function inputCount()
{
  txt = dosnl(this.value);

  this.errorText.data = ' ('+txt.length+' of '+this.textLengthLimit+')';
  if(txt.length>this.textLengthLimit) this.errorText.data+='!!!';
}

// can't do as a prototype due to a flaw in IE
function formValue(e)
{
    if(!e) return null;

    if (e.options)
    {
        if (e.selectedIndex==-1)
            return null;
        else
            return e.options[e.selectedIndex].value;
    }
    else if (e.length)
    {
        for(var i=0;i<e.length;i++)
            if(e[i].checked) return e[i].value;
    }
    else if (e.type.toLowerCase()=="checkbox" && !e.checked) // support single select checkboxes
        return null;
    else
        return e.value;
}

function setSelected(s,v) // only supports single select
{
    var n = parseInt(v);
    if (s.options)
    {
        for(i=0;i<s.options.length;i++)
            if (((n||n==0) && n==parseInt(s.options[i].value,10))||s.options[i].value==v)
            {
                s.selectedIndex = i;
                return;
            }
    }
    else
        for(i=0;i<s.length;i++)
            if (((n||n==0) && n==parseInt(s[i].value,10))||s[i].value==v)
                s[i].checked = true;
            else
                s[i].checked = false;

}

// putting this into String prototype didn't work out too well in FF
function dosnl(s) { return s.replace(LINNL,'$1\r\n').replace(LINNL2,'\n\r\n').replace(LINNL3,'\r\n').replace(MACNL,'\r\n$1').replace(MACNL2,'\r\n\r').replace(MACNL3,'\r\n');}

/***************** Prototype extensions **********************/
// this is a partial adaptation of the demoroniser.pl - more can be added if necessary
// define the bad characters
var SMART_DOUBLE_QUOTES    = new RegExp( '[\u201C\u201D]', 'g' );
var SMART_SINGLE_QUOTES    = new RegExp( '[\u2018\u2019]', 'g' );
var SMART_ELLIPSIS = new RegExp('[\u2026\x85]', 'g');
var SMART_DASHES = new RegExp('[\u2013\u2014]', 'g');
var SMART_BULLET = new RegExp('[\u8226\u8227\u8228\x95\u2022]','g');
String.prototype.demoronise = function()
{
   var str = this.toString();
   str = str.replace(SMART_DOUBLE_QUOTES, '"');
   str = str.replace(SMART_SINGLE_QUOTES, '\'');
   str = str.replace(SMART_ELLIPSIS, '...');
   str = str.replace(SMART_DASHES, '--');
   str = str.replace(SMART_BULLET, '*');
   return str;
}
String.prototype.trim = function() { return this.toString().replace(TRIM,''); }

/***************************** Print Preview **************************/
var chk;        /* track interval*/
var printPopup; /* popup window, initially loaded with blank page */

function applyPrint()
{
    var c; // new stylesheet
    var h; // head node
    var l; // nodelist of links
    if(IE)
    {
        printPopup.document.body.innerHTML = document.body.innerHTML;
        h = printPopup.document.getElementsByTagName('head')[0];
        l = document.getElementsByTagName('link');
        for (j=0;j!=l.length;j++)
        {
            if (l[j].media=='print')
            {
                c = printPopup.document.createElement('link');
                c.type='text/css';
                c.rel='stylesheet';
                c.href=l[j].href;
                h.appendChild(c);
            }
        }
    }
    else
    {
        var x  = printPopup.document.importNode(document.getElementsByTagName('html')[0],true);
        var n  = printPopup.document.getElementsByTagName('html')[0];
        var np = n.parentNode;
        np.removeChild(n);  /* using replaceChild is sometimes buggy when replacing entire doc */
        np.appendChild(x);

        l = printPopup.document.getElementsByTagName('link');
        var a = new Array();
        for (j=0;j!=l.length;j++)
            a.push(l[j]);
        for(j=0;j!=a.length;j++)
        {
            if(a[j].media=='screen')
                a[j].parentNode.removeChild(a[j]);
            else if(a[j].media=='print')
            {
                a[j].removeAttribute('media');
                t = a[j].parentNode;
                t.removeChild(a[j]);
                t.appendChild(a[j]);
            }
        }
    }
    var e = printPopup.document.getElementsByTagName("a");
    var a = new Array();
    for (j=0;j!=e.length;j++)
        a.push(e[j]);

    for(j=0;j!=a.length;j++)
    {
        while(a[j].childNodes.length)
            a[j].parentNode.appendChild(a[j].firstChild);
        a[j].parentNode.removeChild(a[j]);
    }

    printPopup.document.title = document.title;
/*    chk = setInterval(function() { checkLoaded('print_preview',function() { printPopup.print(); }) },1000);*/
}

/* check for existence of element on popup, then invoke callback.
Needed since onload cannot be reliably used */
function checkLoaded(name,callback)
{
    if(printPopup.document.getElementById(name))
    {
        clearInterval(chk);
        callback();
    }
}

function printPreview()
{
    printPopup = window.open('blank.jsp','printable','width=850,height=768,resizable=yes,scrollbars=yes,menubar=yes');
    chk = setInterval(function() { checkLoaded('blank', applyPrint) },50);
}

